# swagger_client

SwaggerClient - the Ruby gem for the Faxsuite RESTful API

<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 4.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.ruby.RubyClientCodegen
For more information, please visit [https://www.fax-api.de/support/](https://www.fax-api.de/support/)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build swagger_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./swagger_client-1.0.0.gem
```
(for development, run `gem install --dev ./swagger_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'swagger_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'swagger_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'swagger_client'
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}
  result = api_instance.get_job(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}/notifications
  result = api_instance.get_job_notifications(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_notifications: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}/preview
  result = api_instance.get_job_previews(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_previews: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job
opts = { 
  object_limit: 100, # Integer | Query parameter to change de default limitation of objects in the result data array
  object_offset: 0, # Integer | Query parameter to change de default offset of objects in the result data array
  filter_fax_number: 'filter_fax_number_example', # String | Query parameter to fetch recipients after his fax number
  filter_fax_number_norm: 'filter_fax_number_norm_example', # String | Query parameter to fetch recipients after his normed fax number
  filter_recipient_reference: 'filter_recipient_reference_example', # String | Query parameter to fetch recipients after his recipient reference
  filter_international_dialing_code: 'filter_international_dialing_code_example', # String | Query parameter to fetch recipients after his international dialing code
  filter_result_code: 'filter_result_code_example', # String | Query parameter to fetch recipients after his result code
  filter_result_text: 'filter_result_text_example', # String | Query parameter to fetch recipients after his result text
  sort_field: 'sort_field_example', # String | Available sort options for the result data array.
  sort_order: 'asc' # String | Describes the order for used sort fields
}

begin
  #/jobs/{id}/recipients
  result = api_instance.get_job_recipients(id, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_recipients: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}/templates
  result = api_instance.get_job_templates(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_templates: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
body = SwaggerClient::JobsIdBody.new # JobsIdBody | Describes the required request body to perform an action on the fax job
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}
  result = api_instance.put_job(body, id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->put_job: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobsApi.new
opts = { 
  object_limit: 100, # Integer | Query parameter to change de default limitation of objects in the result data array
  object_offset: 0, # Integer | Query parameter to change de default offset of objects in the result data array
  filter_same_account: false, # BOOLEAN | Query parameter to fetch jobs after the api account linked to the used token/key for authorization
  filter_title: 'filter_title_example', # String | Query parameter to fetch jobs after his title
  filter_status: 'filter_status_example', # String | Query parameter to fetch jobs after his status
  filter_date_from: DateTime.parse('2013-10-20T19:20:30+01:00'), # DateTime | Query parameter to fetch jobs with a later date in TimeToSend. Can be combined with filterDateTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+01:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
  filter_date_to: DateTime.parse('2013-10-20T19:20:30+01:00'), # DateTime | Query parameter to fetch jobs with a previous date in TimeToSend. Can be combined with filterDateFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+02:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
  filter_date_until_from: DateTime.parse('2013-10-20T19:20:30+01:00'), # DateTime | Query parameter to fetch jobs with a later date in TimeToSendUntil. Can be combined with filterDateUntilTo to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+01:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00)
  filter_date_until_to: DateTime.parse('2013-10-20T19:20:30+01:00'), # DateTime | Query parameter to fetch jobs with a previous date in TimeToSendUntil. Can be combined with filterDateUIntilFrom to define a period of interest. The format must comply with ISO 8601 and must contain date and time, like '2022-01-01T10:00:00+02:00'. Please also consider urlencoding (2022-01-01T10%3A00%3A00%2B01%3A00
  filter_cost_center: 'filter_cost_center_example', # String | Query parameter to fetch jobs after his cost center
  sort_field: 'sort_field_example', # String | Available sort options for the result data array.
  sort_order: 'asc' # String | Describes the order for used sort fields
}

begin
  #/jobs
  result = api_instance.get_jobs(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobsApi->get_jobs: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobsApi.new
body = SwaggerClient::JobPost.new # JobPost | Describes the required request body to create a new fax job


begin
  #/jobs
  result = api_instance.post_job(body)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobsApi->post_job: #{e}"
end
# Setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::RecipientsApi.new
opts = { 
  object_limit: 100, # Integer | Query parameter to change de default limitation of objects in the result data array
  object_offset: 0, # Integer | Query parameter to change de default offset of objects in the result data array
  filter_job_id: 'filter_job_id_example', # String | Query parameter to fetch after recipient related to specific fax job
  filter_same_account: false, # BOOLEAN | Query parameter to fetch recipient related to jobs linked to the used token/key for authorization
  filter_fax_number: 'filter_fax_number_example', # String | Query parameter to fetch recipients after his fax number
  filter_fax_number_norm: 'filter_fax_number_norm_example', # String | Query parameter to fetch recipients after his normed fax number
  filter_recipient_reference: 'filter_recipient_reference_example', # String | Query parameter to fetch recipients after his recipient reference
  filter_international_dialing_code: 'filter_international_dialing_code_example', # String | Query parameter to fetch recipients after his international dialing code
  filter_result_code: 'filter_result_code_example', # String | Query parameter to fetch recipients after his result code
  filter_result_text: 'filter_result_text_example', # String | Query parameter to fetch recipients after his result text
  sort_field: 'sort_field_example', # String | Available sort options for the result data array.
  sort_order: 'asc' # String | Describes the order for used sort fields
}

begin
  #/recipients
  result = api_instance.get_recipients(opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling RecipientsApi->get_recipients: #{e}"
end

api_instance = SwaggerClient::SystemApi.new

begin
  #/health
  result = api_instance.get_health
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling SystemApi->get_health: #{e}"
end
```

## Documentation for API Endpoints

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SwaggerClient::JobDetailsApi* | [**get_job**](docs/JobDetailsApi.md#get_job) | **GET** /jobs/{id} | /jobs/{id}
*SwaggerClient::JobDetailsApi* | [**get_job_notifications**](docs/JobDetailsApi.md#get_job_notifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
*SwaggerClient::JobDetailsApi* | [**get_job_previews**](docs/JobDetailsApi.md#get_job_previews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
*SwaggerClient::JobDetailsApi* | [**get_job_recipients**](docs/JobDetailsApi.md#get_job_recipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
*SwaggerClient::JobDetailsApi* | [**get_job_templates**](docs/JobDetailsApi.md#get_job_templates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
*SwaggerClient::JobDetailsApi* | [**put_job**](docs/JobDetailsApi.md#put_job) | **PUT** /jobs/{id} | /jobs/{id}
*SwaggerClient::JobsApi* | [**get_jobs**](docs/JobsApi.md#get_jobs) | **GET** /jobs | /jobs
*SwaggerClient::JobsApi* | [**post_job**](docs/JobsApi.md#post_job) | **POST** /jobs | /jobs
*SwaggerClient::RecipientsApi* | [**get_recipients**](docs/RecipientsApi.md#get_recipients) | **GET** /recipients | /recipients
*SwaggerClient::SystemApi* | [**get_health**](docs/SystemApi.md#get_health) | **GET** /health | /health

## Documentation for Models

 - [SwaggerClient::ErrorAuthenticationResponse](docs/ErrorAuthenticationResponse.md)
 - [SwaggerClient::ErrorBadRequestResponse](docs/ErrorBadRequestResponse.md)
 - [SwaggerClient::ErrorInternalServerResponse](docs/ErrorInternalServerResponse.md)
 - [SwaggerClient::ErrorNotFoundResponse](docs/ErrorNotFoundResponse.md)
 - [SwaggerClient::ErrorServiceNotAvailableResponse](docs/ErrorServiceNotAvailableResponse.md)
 - [SwaggerClient::ErrorToManyRequestsResponse](docs/ErrorToManyRequestsResponse.md)
 - [SwaggerClient::Health](docs/Health.md)
 - [SwaggerClient::InlineResponse201](docs/InlineResponse201.md)
 - [SwaggerClient::Job](docs/Job.md)
 - [SwaggerClient::JobInfo](docs/JobInfo.md)
 - [SwaggerClient::JobOptions](docs/JobOptions.md)
 - [SwaggerClient::JobPost](docs/JobPost.md)
 - [SwaggerClient::JobPostOptions](docs/JobPostOptions.md)
 - [SwaggerClient::JobPostRecipient](docs/JobPostRecipient.md)
 - [SwaggerClient::JobRecipient](docs/JobRecipient.md)
 - [SwaggerClient::JobRecipients](docs/JobRecipients.md)
 - [SwaggerClient::JobStatistics](docs/JobStatistics.md)
 - [SwaggerClient::Jobs](docs/Jobs.md)
 - [SwaggerClient::JobsIdBody](docs/JobsIdBody.md)
 - [SwaggerClient::Notification](docs/Notification.md)
 - [SwaggerClient::Notifications](docs/Notifications.md)
 - [SwaggerClient::Preview](docs/Preview.md)
 - [SwaggerClient::Recipient](docs/Recipient.md)
 - [SwaggerClient::RecipientJob](docs/RecipientJob.md)
 - [SwaggerClient::Recipients](docs/Recipients.md)
 - [SwaggerClient::Template](docs/Template.md)
 - [SwaggerClient::Templates](docs/Templates.md)

## Documentation for Authorization


### ApiAuthKey

- **Type**: API key
- **API key parameter name**: X-Auth-Token
- **Location**: HTTP header

